#include "ej13.h"
#include <iostream>

using namespace std;

Conjunto::Conjunto() 
{
  vacia();
}

void Conjunto::vacia() 
{
  ultima_pos = PRIMERA_POS;
}

bool Conjunto::estaVacio() 
{
  return ultima_pos == PRIMERA_POS;
}

int Conjunto::getValor(int pos) 
{
  if (pos < 0 || pos >= ultima_pos) {
    cout << "Error se ha intentado acceder a una posicion invalida del conjunto" << endl;
    return -1;
  }
  else {
    return valores[pos];
  }
}

void Conjunto::agregar(int numero) 
{
  if (!estaNumero(numero)) {
    if (ultima_pos == MAX_TAM) {
      cout << "ERROR: capacidad maxima alcanzada" << endl;
    }
    else { // se realiza la insercion
      valores[ultima_pos++] = numero; 
    }
  }
}

bool Conjunto::estaNumero(int numero)
{
  bool encuentra = false;
  for (int i=0; i<ultima_pos && !encuentra; i++) {
    if (valores[i] == numero) encuentra = true;
  }

  return encuentra;
}

void Conjunto::imprimir()
{
  cout << "(";
  for (int i=0; i<ultima_pos; i++) {
    cout << valores[i] << ", ";
  }
  cout << ")";
  cout << endl;
}

int Conjunto::tamanyo() 
{
  return ultima_pos;
}

int Conjunto::posicion(int numero)
{
  int pos = -1;
  for (int i=0; i<ultima_pos; i++) {
    if (valores[i] == numero) {
      pos = i;
      break;
    }
  }

  return pos;
}

void Conjunto::eliminar(int numero) 
{
  int pos = posicion(numero);
  if (pos == -1) {
    cout << "ERROR: Objeto no encontrado" << endl;
  }
  else {
    for (int i=pos; i<ultima_pos-1; i++) {
      valores[i] = valores[i+1];
    }
    ultima_pos--;
  }
}

void Conjunto::copiar(Conjunto conjunto)
{
  ultima_pos = conjunto.tamanyo();
  for (int i=0; i<ultima_pos; i++) {
    valores[i] = conjunto.getValor(i);
  }
}

bool Conjunto::esIgual(Conjunto conjunto) 
{
  bool iguales = true;
  if (conjunto.tamanyo() != tamanyo()) {
    iguales = false;
  }
  else {
    for (int i=0; i<ultima_pos && iguales; i++) {
      if (conjunto.getValor(i) != valores[i]) {
        iguales = false;
      }
    }
  }

  return iguales;

}

int main() 
{
  Conjunto c; 
  c.vacia();
  c.imprimir();
  cout << "esta vacio: " << c.estaVacio() << endl;
  cout << "tamanho es " << c.tamanyo() << endl;
  c.agregar(1);
  c.agregar(1);
  c.agregar(2);
  c.agregar(3);
  c.imprimir();
  cout << "tamanho es " << c.tamanyo() << endl;
  cout << "esta vacio: " << c.estaVacio() << endl;
  cout << "el ultimo elemento es " << c.getValor(c.tamanyo()-1) << endl;
  cout << "esta el 1 " << c.estaNumero(1) << " el 2: " << c.estaNumero(2) << " el 3 " << c.estaNumero(3) << " el 5 " << c.estaNumero(5) << endl;
  cout << "posicion del 1 es " << c.posicion(1) << " del 2: " << c.posicion(2) << " 3: " << c.posicion(3) << " del 5 es " << c.posicion(5) << endl;
  c.eliminar(1);
  c.imprimir();
  c.eliminar(3);
  c.imprimir();

  Conjunto c2;
  c2.agregar(4);
  c2.agregar(5);
  c2.agregar(6);
  cout << "es igual a c2: " << c.esIgual(c2) << endl;
  c.copiar(c2);
  c.imprimir();
  cout << "es igual a c2: " << c.esIgual(c2) << endl;

}
